;; Reverse of stage A
;; Find key bytes to give ebx the final value found in stage B

Code Segment Byte Public
Assume   Ds:Code,Cs:Code
Org  100h
P386

KeyLen equ 6    ; in bytes

Start:
     ;; Find correct password
        Mov edi, offset Key+KeyLen-1
        Mov ebx, InitialEBX

        Mov cl, KeyLen
@l1:
        Mov edx, FinalEBX

        Mov ch,cl
@l2:
        Ror edx, 5
        Dec ch
        jnz @l2
        And edx,03eh

        Mov eax,ebx
        And eax,03fh
        Test eax,1
        jz $+4
        inc bl

        Sub dl,al

        Add bl,dl
        Rol ebx,5
        xchg al,dl
        Std
        Stosb
        Cld
        dec cl
        jnz @l1

        .IF ebx!= FinalEBX      ;; Exit on error
          ret
        .ENDIF
     ;; Save found key
        Mov cx, KeyLen
        Mov esi, offset Key
        Mov edi, offset Key+KeyLen
        Repnz Movsb

     ;; Fix password -> Correct for typeable chars
        Mov esi, offset Key
        Mov cx, KeyLen
@l3:    Push cx
        Lodsb
        .IF (! ((al>=20h)&&(al<=7Eh)) ) ;; Not typeable

          Mov ah,al
          Xor ah,00100000b
          .IF (! ((ah>=20h)&&(ah<=7Eh)) ) ;; Not typeable
             Mov ah,al
             Xor ah,01000000b
             .IF (! ((ah>=20h)&&(ah<=7Eh)) ) ;; Not typeable
                Mov ah,al
                Xor ah,10000000b
             .ENDIF
          .ENDIF

         ;; Now ah is typeable.. need to fix other byte in key
         ;; to keep FinalEBX the same.


          Mov byte ptr [si-1],ah
          .IF si==offset Key+KeyLen  ;; Last char? -> Manualy (:


          .ELSE                      ;; No -> Other byte == next byte
            And byte ptr [si],0F0h
            Mov cx,10h               ;; try all possible 16h chars
          @l4:
            Call CalcEBX
            .IF ebx!=FinalEBX
               Inc byte ptr [si]
               Loop @l4
            .ELSE

            .ENDIF
          .ENDIF


        .ENDIF
        Pop cx
        Loop @l3


        ret

;; Simulate the crackme..Find ebx if we input the bytes currently in Key
CalcEBX Proc
        Push esi ecx
        Mov ebx, InitialEBX
        Mov cx, KeyLen

        Mov esi, OFFSET Key+KeyLen-1
        Std
        Test ebx, 01
        jz $+3
        Stc
@l5:    Lodsb
        Adc bl,al
        Rol ebx,5
        Loop @l5
        Cld
        Pop ecx esi
        ret
CalcEBX Endp

InitialEBX dd 05094C71h
FinalEBX   dd 0EDD91979h
Key:

Code Ends
End Start
